#ifndef OBJECT
#define OBJECT

#include <iostream>
#include <list>
#include "../gra/mathlib.h"
#include "./deftype.h"
#include "./decoration.h"

using namespace std;


string GetNameForType (int in);
int QuickPower (int Base, int Power);

struct IndObject
{
string Name;
int ID, Type;
};

/** Object is a base class for all object in the game world

    Базовый класс для всех обьектов в игровом мире
*/
class Object
{
float *t;
IndObject Ind;
public:
virtual ~Object()=0;
/** This function for draw object if child object not have
    function Draw return Error = (int)-1
*/
virtual int Draw (){return -1;}
/** Virtual Init function for Object. 
*/
virtual int Init (){return -1;}
virtual int SC (){ return -1;}
virtual int Calc (){return -1;}

//----
void InitT (float *in){t = in;}
void WriteName (string in){Ind.Name = in;}
void WriteType (int in){Ind.Type = in;}
void WriteID (int in){Ind.ID = in;}
string GetName (){return Ind.Name;}
int GetId (){return Ind.ID;}
int GetType (){return Ind.Type;}
};

struct UObject
{
Object *in;
void Free (){delete in;}
};

typedef list < UObject > ObjectList;

#define SizeSector 30


class SublimatObjects
{
ObjectList SubObjects, *SectorObjects;
DecorationObjectList DecorationList;
int SizeSublimat, nSectors, lenghS, sSub;
vec2 nXYSector;
public:
~SublimatObjects ()
	{
	ObjectList::iterator object_iterator_1;
	for (object_iterator_1=SubObjects.begin();
		     object_iterator_1!=SubObjects.end();
		     ++object_iterator_1)
			{
			object_iterator_1->Free();
			}
	delete[] SectorObjects;
	}
SublimatObjects (){}
SublimatObjects (int sSub){Init (sSub);}
void Init (){Init (sSub);}
void Init (int sSubi)
	{
	sSub = sSubi;
	SizeSublimat = sSub;
	nSectors = SizeSublimat / (SizeSector*SizeSector);
	lenghS = (int) sqrt ((double) nSectors);
	SectorObjects = new ObjectList[nSectors];
	cout << "nSectors:" << nSectors << endl;
	cout << "lenghS:" << lenghS << endl;
	}
void WritesSub (int in){sSub = in;}
vec2 GetXYSectorN(vec2 in)
	{
	vec2 out;
	out.x=((lenghS * SizeSector) / 2 + (int) in.x) / SizeSector;
	out.y=(((lenghS * SizeSector) / 2 + (int) in.y) / SizeSector) * lenghS;
	return out;
	}
int GetSectorN (vec2 in){return GetSectorN (in.x, in.y);}
int GetSectorN (vec2 in, int *outx, int *outy){return GetSectorN (in.x, in.y, outx, outy);}
int GetSectorN (float x, float y)
	{
	int Sec=(((lenghS * SizeSector) / 2 + (int) y) / SizeSector) * lenghS +
	((lenghS * SizeSector) / 2 + (int) x) / SizeSector;
	return Sec;
	}
int GetSectorN (float x, float y, int *outx, int *outy)
	{	
	(*outy)=((lenghS * SizeSector) / 2 + (int) y) / SizeSector;
	(*outx)=((lenghS * SizeSector) / 2 + (int) x) / SizeSector;
	return (*outy)* lenghS+(*outx);
	}
int Get4Sector (int n, float x, float y);
int GetnSectors (){return nSectors;}
int GetlenghS (){return lenghS;}
int GetSizeS (){return SizeSector;}
ObjectList *GetSO (){return &SubObjects;}
ObjectList *GetSeO (){return SectorObjects;}
Object *GetShipByName (string ship_name);
DecorationObjectList *GetDecorationList(){return &DecorationList;}
};

ObjectList GetViewObjectList (ObjectList * inlist, int sector, int sectro4,
			      int lenS, int nsectors);

class WorldObjects
{
SublimatObjects *WorldSubOb;
int nWorld;
public:
SublimatObjects * GetSub (int in)
	{
	if(in<nWorld)
		return &WorldSubOb[in];
	return NULL;
	}
WorldObjects (int n)
	{
	nWorld = n;
	WorldSubOb = new SublimatObjects[n];
	}
int GetnWorld (){return nWorld;}
void DeleteWorld()
	{
	delete[] WorldSubOb;
	}
};

#endif
